<?php
/*
  $Id: ckmerchantpartners.php,v 1.2 2005/06/15 18:43:57 lane Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
----- Tony Cun tcun@merchantpartners.com ------

	Updated by: IFD OSC-MODSQUAD.COM
	Updated Updated to v1.61 by: Tony Cun - correction to the billing/shipping address
	Updated to v1.66 by: Tony Cun - MerchantPIN and cURL support
	Updated to v1.66 by: Tony Cun - Support systems where PHP is not compiled with cURL support
	Updated to v1.67 by: Tony Cun - Support Extended ACH
*/

  class ckmerchantpartners {
    var $code, $title, $description, $enabled;

// class constructor
    function ckmerchantpartners() {
      global $order;

      $this->code = 'ckmerchantpartners';
      $this->title = MODULE_PAYMENT_CKMERCHANTPARTNERS_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_CKMERCHANTPARTNERS_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_CKMERCHANTPARTNERS_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_CKMERCHANTPARTNERS_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_CKMERCHANTPARTNERS_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_CKMERCHANTPARTNERS_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      $this->form_action_url = tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL', true);

    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_CKMERCHANTPARTNERS_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_CKMERCHANTPARTNERS_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      $js = '  if (payment_value == "' . $this->code . '") {' . "\n" .
            '    var ck_owner = document.checkout_payment.ckmerchantpartners_ck_owner.value;' . "\n" .
            '    var ck_number = document.checkout_payment.ckmerchantpartners_ck_number.value;' . "\n" .
            '    if (ck_owner == "") { ' . "\n" .
            '      error_message = error_message + "' . MODULE_PAYMENT_CKMERCHANTPARTNERS_TEXT_JS_CK_OWNER . '";' . "\n" .
            '      error = 1;' . "\n" .
            '    }' . "\n" .
            '    if (ck_number == "") {' . "\n" .
            '      error_message = error_message + "' . MODULE_PAYMENT_CKMERCHANTPARTNERS_TEXT_JS_CK_NUMBER . '";' . "\n" .
            '      error = 1;' . "\n" .
            '    }' . "\n" .
            '  }' . "\n";

      return $js;
    }

    function selection() {
      global $order;

      for ($i=1; $i < 13; $i++) {
        $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
      }

      $today = getdate();
      for ($i=$today['year']; $i < $today['year']+10; $i++) {
        $expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
      }
      $finalform = array();
      $finalform = array(array('title' => MODULE_PAYMENT_CKMERCHANTPARTNERS_TEXT_CHECK_OWNER,
                                                 'field' => tep_draw_input_field('ckmerchantpartners_ck_owner', $order->billing['firstname'] . ' ' . $order->billing['lastname']))
,
                                           array('title' => MODULE_PAYMENT_CKMERCHANTPARTNERS_TEXT_CHECK_NUMBER,
                                                 'field' => tep_draw_input_field('ckmerchantpartners_ck_number')),
                                           array('title' => MODULE_PAYMENT_CKMERCHANTPARTNERS_TEXT_CHECK_ABA,
                                                 'field' => tep_draw_input_field('ckmerchantpartners_ck_aba')));

      if (MODULE_PAYMENT_CKMERCHANTPARTNERS_ACHTYPE == "ACH") {
         $ckaccttype_list = array(array('id' => "1", 'text' => "Personal Checking"), array('id' => "2", 'text' => "Personal Savings"));
         $finalform1 = array(array('title' => "ACH Transaction Type",
                          'field' => tep_draw_pull_down_menu('ckaccttype', $ckaccttype_list)));
         $finalform = array_merge($finalform, $finalform1);

      }
      if (MODULE_PAYMENT_CKMERCHANTPARTNERS_ACHTYPE == "ExtACH") {
         $ckaccttype_list = array(array('id' => "3", 'text' => "Personal Checking"), array('id' => "4", 'text' => "Personal Savings"), array('id' => "5", 'text' => "Business Checking"), array('id' => "6", 'text' => "Business Savings"));
         $finalform1 = array(array('title' => "ACH Transaction Type",
                          'field' => tep_draw_pull_down_menu('ckaccttype', $ckaccttype_list)));
         $finalform = array_merge($finalform, $finalform1);
      }
      if (MODULE_PAYMENT_CKMERCHANTPARTNERS_ACHTYPE == "ExtACHCK21") {
         $ckaccttype_list = array(array('id' => "7", 'text' => "Personal"), array('id' => "8", 'text' => "Business"));
         $finalform1 = array(array('title' => "ACH Transaction Type",
                          'field' => tep_draw_pull_down_menu('ckaccttype', $ckaccttype_list)));
         $finalform = array_merge($finalform, $finalform1);
      }

      $selection = array('id' => $this->code,
                         'module' => $this->title,
                         'fields' => $finalform);

      return $selection;
    }


    function pre_confirmation_check() {
      global $HTTP_POST_VARS;

      include(DIR_WS_CLASSES . 'cc_validation.php');

      $cc_validation = new cc_validation();
      $result = '1';

      $error = '';
      switch ($result) {
        case -1:
          $error = sprintf(TEXT_CCVAL_ERROR_UNKNOWN_CARD, substr($cc_validation->ck_number, 0, 4));
          break;
        case -2:
        case -3:
        case -4:
          $error = TEXT_CCVAL_ERROR_INVALID_DATE;
          break;
        case false:
          $error = TEXT_CCVAL_ERROR_INVALID_NUMBER;
          break;
      }

      if ( ($result == false) || ($result < 1) ) {
        $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) . '&ckmerchantpartners_cc_owner=' . urlencode($HTTP_POST_VARS['ckmerchantpartners_cc_owner']) . '&ckmerchantpartners_cc_expires_month=' . $HTTP_POST_VARS['ckmerchantpartners_cc_expires_month'] . '&ckmerchantpartners_cc_expires_year=' . $HTTP_POST_VARS['ckmerchantpartners_cc_expires_year'] . '&ckmerchantpartners_cc_checkcode=' . $HTTP_POST_VARS['ckmerchantpartners_cc_checkcode'];

        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }

      $this->cc_card_type = 'CK';
      $this->ck_number = $HTTP_POST_VARS['ckmerchantpartners_ck_number'];
      $this->ck_aba = $HTTP_POST_VARS['ckmerchantpartners_ck_aba'];
      $this->ck_owner = $HTTP_POST_VARS['ckmerchantpartners_ck_owner'];
    }

    function confirmation() {
      global $HTTP_POST_VARS;

      $confirmation = array('title' => $this->title . ': ' . $this->cc_card_type,
                            'fields' => array(array('title' => MODULE_PAYMENT_CKMERCHANTPARTNERS_TEXT_CHECK_OWNER,
                                                    'field' => $this->ck_owner),
                                              array('title' => MODULE_PAYMENT_CKMERCHANTPARTNERS_TEXT_CHECK_NUMBER,
                                                    'field' => substr($this->ck_number, 0, 2) . str_repeat('X', (strlen($this->ck_number) -4)) . substr($this->ck_number, -2)),
                                              array('title' => MODULE_PAYMENT_CKMERCHANTPARTNERS_TEXT_CHECK_ABA,
                                                    'field' => substr($this->ck_aba, 0, 2) . str_repeat('X', (strlen($this->ck_aba) -4)) . substr($this->ck_aba, -2))));

      return $confirmation;
    }


   function process_button() {
    global $HTTP_POST_VARS, $HTTP_GET_VARS, $order, $customer_id, $session_id, $emailtext, $merchantordernumber;

       $process_button_string =   tep_draw_hidden_field('ckname', $this->ck_owner) .
                               tep_draw_hidden_field('ckacct', $this->ck_number) .
                               tep_draw_hidden_field('ckaba', $this->ck_aba) .
                               tep_draw_hidden_field('emailtext', $emailtext) .
                               tep_draw_hidden_field('merchantordernumber', $merchantordernumber) .
                               tep_draw_hidden_field('ckaccttype', $HTTP_POST_VARS['ckaccttype']) .
                               tep_draw_hidden_field('ci_memo', $HTTP_POST_VARS['comments']);
       if (MODULE_PAYMENT_CKMERCHANTPARTNERS_ACHTYPE == "ExtACH") {
          $process_button_string .= tep_draw_hidden_field('ckno', $HTTP_POST_VARS['ckno']) .
                                    tep_draw_hidden_field('achtransactiontype', "WEB");
       }
       if (MODULE_PAYMENT_CKMERCHANTPARTNERS_ACHTYPE == "ExtACHCK21") {
          $address = explode(" ", $order->billing['street_address']);
          $process_button_string .= tep_draw_hidden_field('ci_billhousenumber', $address[0]) .
                                    tep_draw_hidden_field('ci_billstreet', $address[1]) .
                                    tep_draw_hidden_field('ci_firstname', $order->billing['firstname']) .
                                    tep_draw_hidden_field('ci_lastname', $order->billing['lastname']);

       }


      return $process_button_string;
    }

    function before_process() {
    global $HTTP_POST_VARS, $HTTP_GET_VARS, $order, $emailtext, $merchantordernumber, $orderid;
             $ckaccttype = "";
             switch($HTTP_POST_VARS['ckaccttype']) {
                case 1:
                  $ckaccttype = "1";
                  break;
                case 2:
                  $ckaccttype = "2";
                  break;
                case 3:
                  $ckaccttype = "Personal Checking";
                  break;
                case 4:
                  $ckaccttype = "Personal Saving";
                  break;
                case 5:
                  $ckaccttype = "Business Checking";
                  break;
                case 6:
                  $ckaccttype = "Business Saving";
                  break;
                case 7:
                  $ckaccttype = "P";
                  break;
                case 8:
                  $ckaccttype = "B";
                  break;
                default:
                  $ckaccttype = "1";
                  break;

             }

	     $url="https://trans.merchantpartners.com/cgi-bin/process.cgi";
	     $params = array(
	        acctid => MODULE_PAYMENT_CKMERCHANTPARTNERS_ACCTID,
	        subid => MODULE_PAYMENT_CKMERCHANTPARTNERS_SUBID,
	        merchantpin => MODULE_PAYMENT_CKMERCHANTPARTNERS_MERCHANTPIN,
	        amount => number_format($order->info['total'], 2, '.', ''),
	        ci_email => $order->customer['email_address'],
		    ci_billaddr1 => $order->billing['street_address'],
		    ci_billaddr2 => $order->billing['suburb'],
		    ci_billcity => $order->billing['city'],
		    ci_billstate => $order->billing['state'],
		    ci_billzip => $order->billing['postcode'],
		    ci_billcountry => $order->billing['country']['title'],
		    ci_consumername => $order->delivery['firstname'] . ' ' . $order->delivery['lastname'],
		    ci_shipaddr1 => $order->delivery['street_address'],
		    ci_shipaddr2 => $order->delivery['suburb'],
		    ci_shipcity => $order->delivery['city'],
		    ci_shipstate => $order->delivery['state'],
		    ci_shipzip => $order->delivery['postcode'],
	        ci_shipcountry => $order->delivery['country']['title'],
	        merchantordernumber => $HTTP_POST_VARS['merchantordernumber'],
            ci_phone => $order->customer['telephone'],
	    	ccname => $HTTP_POST_VARS['ckname'],
	    	ckacct => $HTTP_POST_VARS['ckacct'],
	    	ckaba => $HTTP_POST_VARS['ckaba'],
            ci_ipaddress => $_SERVER['REMOTE_ADDR'],
	    	emailtext => $emailtext);
             if (MODULE_PAYMENT_CKMERCHANTPARTNERS_ACHTYPE == "ACH") {
                $params1 = array(action => "ns_quicksale_check",
                                 acctdata3 => $ckaccttype);
             }
             if (MODULE_PAYMENT_CKMERCHANTPARTNERS_ACHTYPE == "ExtACH") {
                $params1 = array(action => "extach_sale",
                                 achtransactiontype => "WEB",
                                 accounttypedesc => $ckaccttype);
             }
             if (MODULE_PAYMENT_CKMERCHANTPARTNERS_ACHTYPE == "ExtACHCK21") {
                $params1 = array(action => "extach_ck21sale",
                                 ckaccttype => $ckaccttype,
                                 ci_billhousenumber => $HTTP_POST_VARS['ci_billhousenumber'],
                                 ci_billstreet => $HTTP_POST_VARS['ci_billstreet'],
                                 ci_firstname => $HTTP_POST_VARS['ci_firstname'],
                                 ci_lastname => $HTTP_POST_VARS['ci_lastname']);
             }
             $params = array_merge($params, $params1);

	     while(list($key, $val) = each($params)) {
	     	$formargs .= $key . '=' . urlencode(ereg_replace(',', '', $val)) . '&';
	     }
             if (function_exists('curl_init')) {
	        $ch=curl_init();
	        curl_setopt($ch, CURLOPT_URL, $url);
	        curl_setopt($ch, CURLOPT_TIMEOUT, 180); // should never take more than 3 mins
	        curl_setopt($ch, CURLOPT_POST, 1);
	        curl_setopt($ch, CURLOPT_POSTFIELDS, $formargs);
	        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	        $result=curl_exec($ch);
	        $fatal_error=curl_error($ch);
	        curl_close($ch);
             } else {
                exec(escapeshellarg(MODULE_PAYMENT_CKMERCHANTPARTNERS_CURL) . ' -d ' . escapeshellarg($formargs) . ' "' . $url . '" -P ' . '443' . ' -k', $result);
                $result = implode("\n", $result );
             }
	     $result = explode("\n", $result ); // parsing text/html outputs
	     $totalVars = count($result);

	     for ($i=0; $i<$totalVars; $i++) {
	        $resultTempVars = explode("=", rtrim($result[$i]));
	        $resultVars[$resultTempVars[0]] = $resultTempVars[1];
	     }

	     if ($resultVars[Status] != "Accepted") {
	        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code . '&error=' . $resultVars['Declined'] . $fatal_error, 'SSL', true));
	     }
	     $orderid = $resultVars['orderid'];
             return $orderid;
          }



    function after_process() {
      return false;
    }

    function get_error() {
      global $HTTP_GET_VARS, $HTTP_POST_VARS;

      if (isset($HTTP_GET_VARS['Status'])) {
         $error = array('title' => CKMERCHANTPARTNERS_ERROR_HEADING,
                     'error' => stripslashes(urldecode($HTTP_GET_VARS['Status'])) . ': ' .  stripslashes(urldecode($HTTP_GET_VARS['reason'])) . stripslashes(urldecode($HTTP_GET_VARS['Reason'])));
      }
      else {
      $error = array('title' => CKMERCHANTPARTNERS_ERROR_HEADING,
                     'error' => stripslashes(urldecode($HTTP_GET_VARS['error'])));
      }
      return $error;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_CKMERCHANTPARTNERS_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Merchant Partners Check Module', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_STATUS', 'True', 'Do you want to accept Merchant Partners payments?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('AcctID', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_ACCTID', 'TEST0', 'The acctID used for the merchantPartners service', '6', '2', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('SubID', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_SUBID', '', 'The subID for the merchantPartners service', '6', '3', now())");
   	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant PIN', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_MERCHANTPIN', '', 'The MerchantPIN for the service', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Standard ACH or Extended ACH', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_ACHTYPE', 'ACH', 'Default is Standard ACH.  You must be approved to use Extended ACH', '6', '8', 'tep_cfg_select_option(array(\'ACH\', \'ExtACH\', \'ExtACHCK21\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '5', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '6', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Path to cURL', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_CURL', '/usr/bin/curl', 'The path to cURL if not compiled/enabled in PHP', '6', '7', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_CKMERCHANTPARTNERS_STATUS', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_ACCTID', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_SUBID', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_MERCHANTPIN', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_ACHTYPE', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_ZONE', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_ORDER_STATUS_ID', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_CURL', 'MODULE_PAYMENT_CKMERCHANTPARTNERS_SORT_ORDER');
    }
  }
?>

